#include <iostream>
#include <string>
#include <bits/stdc++.h>
#include <stdlib.h>
#include <cstdlib>
#include <algorithm>
using namespace std;
int main()
{
    int n;
    cin>>n;
    int matrica[n][n];
    string sio[n][n];
    int a,b;
    for(int i=0;i<n;i++)
    {
      for(int j=0;j<n;j++)
      {
        matrica[i][j]=9999;
        sio[i][j]="lopovi";
      }
    }
    for(int i=0;i<n;i++)
    {
      cin>>a>>b;
      matrica[a][b]=1;
      cin>>sio[a][b];
    } 
    /*for(int i=0;i<n;i++)
    {
      for(int j=0;j<n;j++)
      {
        cout<<sio[i][j]<<" ";
      }
      cout<<endl;
    }*/
    for(int i=0;i<n;i++)
    {
      for(int j=0;j<n;j++)
      {
        for(int k=0;k<n;k++)
        {
          if(matrica[i][j]>matrica[i][k]+matrica[k][j])
          {
            matrica[i][j]=matrica[i][k]+matrica[k][j];
            sio[i][j]=sio[i][k]+sio[k][j];
          }
        }
      }
      
    }
    int res[n][n];
    for(int i=0;i<n;i++)
    {
      for(int j=0;j<n;j++)
      {
        if(count(sio[i][j].begin(), sio[i][j].end(), 's')==count(sio[i][j].begin(), sio[i][j].end(), 'i')==count(sio[i][j].begin(), sio[i][j].end(), 'o'))
        {
          res[i][j]=1;
        }
      }
    }
    int s=0;
    for(int i=0;i<n;i++)
    {
      for(int j=0;j<n;j++)
      {
        if(res[i][j]==1) s++;
      }
    }
    cout<<s;
}